#camera.py

import select
import v4l2capture
import time
class VideoCamera(object):
    #globals for testing
    size_x=0
    size_y=0
    
    # intitialize
    def __init__(self):
        # grab camera
        self.video = v4l2capture.Video_device("/dev/video0")
        #set format the python version of v4l2 and v4l2capture API's are not the great
        size_x, size_y = self.video.set_format(640, 480, fourcc='MJPG')
        print ('size :',size_x,size_y)
        #create a memory buffer for the jpgs
        self.video.create_buffers(1)
        self.video.queue_all_buffers()
        # start the vidoe capture process
        self.video.start()
    # destructor
    def __del__(self):
        self.video.close()
    # capture image
    def get_frame(self):
        #before = time.clock()
        #not sure what select.select is doing
        select.select((self.video,), (), ())
        # read and queue set the motion so to speak, with read alone you only get the first image on start 
        jpeg = self.video.read_and_queue()
        #print 1/(time.clock()-before)
        return jpeg